# Nix

Nix is a powerful package manager and build system that offers a unique approach to managing software dependencies and environments. Unlike traditional package managers, Nix employs a purely functional paradigm, which ensures reproducibility, atomic upgrades, and precise dependency management. This overview provides insight into the fundamental concepts and features of Nix.

## Nix - Package manager

As stated above, `Nix` is mainly a package manager available for every major operating system (`MacOS`, `Linux`, `Windows`) but it also provides a [Docker](https://www.docker.com) image.  

You can find the detailed steps and available options on [nixos.org](https://nixos.org/download)

## NixOS - Linux based operating system

On the other hand, `Nix` comes as a `Linux` based operating system. It diverges from traditional distributions by embracing the principles of Nix, a purely functional package manager and build system. NixOS provides a novel approach to system configuration and package management, offering declarative, reproducible, and atomic system configurations.  
Everything is declared in a `configuration.nix` file. Every bit of the configured system is reproducible on any other `NixOS` installation by importing the `configuration.nix` onto it.

To install `NixOS`, go to [nixos.org](https://nixos.org/download), download either the `Graphical ISO image` for a complete system (choose your DE in the list) or the `Minimal ISO image`.  
Note, `NixOS` also comes in a [Virtual Box](https://www.virtualbox.org/) image. Cool, right ? As this wasn't enough, they give you a CLI command to spawn an [EC2](https://aws.amazon.com/fr/ec2/) instance.

## Nix-Darwin - NixOS layer for MacOS

[nix-darwin](https://github.com/LnL7/nix-darwin) is a project that brings the power of the Nix package manager and the declarative configuration style of NixOS to macOS systems. It allows macOS users to manage their system configuration, install software, and maintain their environment using Nix principles. This overview provides insight into the key concepts, features, and components of nix-darwin.
